# no optimization directives needed since CCE enables them by default
COMPILER = {
    'compile': 'CC',
    'debug'  : 'CC -g',
    'profile': 'CC',
    'libs'   : ''
}

MPI_COMPILER = {
    'compile': 'CC',
    'debug'  : 'CC -g',
    'profile': 'CC',
    'libs'   : ''
}

MPI_RUN = '-n %(nprocs)d -N %(ptile)d %(cmd)s%(suffix)s'

PROFILE_PREPROC = 'pat_build -O apa -g mpi,io %(name)s'
PROFILE_SUFFIX  = '+pat'

WALLTIME = '1'
MEMORY   = '1024'
PTILE    = '32'

JOB_SUBMIT = '''echo "#!/bin/bash
#SBATCH --job-name=%(name)s
#SBATCH --nodes=%(nodes)d
#SBATCH --time=%(walltime)d:00:00
#SBATCH --mem-per-cpu=%(memory)d
#SBATCH --account=s345
ulimit -c 0
%(xopts)s
aprun %(cmd)s" | sbatch
'''

CLUSTER = 'Todi - Cray XK6 (CSCS, Lugano)'
