
// This file is automatically generated by 'make.py' script

#include "equation.h"
#include "multi_mpi.h"
#include "mpi.h"

void set_ghost_x()
{
  for (int i = 0; i < GX; i++) {
    for (int j = 0; j < NYl; j++) {
      for (int k = 0; k < NZl; k++) {
        if (mpibc[X]) {
          U[-1-i][j][k] = mpi_rbuf[mpi_bc_rbuf[X]][(i*NYl + j)*NZl + k];
        } else {
          U[-1-i][j][k] = U[NXl-1-i][j][k];
          bc_fix(-1-i,j,k,NXl-1-i,j,k);
        }
        calc_xtra(Xtra[-1-i][j][k], U[-1-i][j][k], -1-i, j, k);
        if (mpibc[X+NDIR]) {
          U[NXl+i][j][k] = mpi_rbuf[mpi_bc_rbuf[X+NDIR]][(i*NYl + j)*NZl + k];
        } else {
          U[i+NXl][j][k] = U[i][j][k];
          bc_fix(i+NXl,j,k,i,j,k);
        }
        calc_xtra(Xtra[i+NXl][j][k], U[i+NXl][j][k], i+NXl, j, k);
      }
    }
  }
}

void set_ghost_y()
{
  for (int i = 0; i < NXl; i++) {
    for (int j = 0; j < GY; j++) {
      for (int k = 0; k < NZl; k++) {
        if (mpibc[Y]) {
          U[i][-1-j][k] = mpi_rbuf[mpi_bc_rbuf[Y]][(i*GY + j)*NZl + k];
        } else {
          U[i][-1-j][k] = U[i][NYl-1-j][k];
          bc_fix(i,-1-j,k,i,NYl-1-j,k);
        }
        calc_xtra(Xtra[i][-1-j][k], U[i][-1-j][k], i, -1-j, k);
        if (mpibc[Y+NDIR]) {
          U[i][NYl+j][k] = mpi_rbuf[mpi_bc_rbuf[Y+NDIR]][(i*GY + j)*NZl + k];
        } else {
          U[i][j+NYl][k] = U[i][j][k];
          bc_fix(i,j+NYl,k,i,j,k);
        }
        calc_xtra(Xtra[i][j+NYl][k], U[i][j+NYl][k], i, j+NYl, k);
      }
    }
  }
}

void set_ghost_z()
{
  for (int i = 0; i < NXl; i++) {
    for (int j = 0; j < NYl; j++) {
      for (int k = 0; k < GZ; k++) {
        if (mpibc[Z]) {
          U[i][j][-1-k] = mpi_rbuf[mpi_bc_rbuf[Z]][(i*NYl + j)*GZ + k];
        } else {
          U[i][j][-1-k] = U[i][j][NZl-1-k];
          bc_fix(i,j,-1-k,i,j,NZl-1-k);
        }
        calc_xtra(Xtra[i][j][-1-k], U[i][j][-1-k], i, j, -1-k);
        if (mpibc[Z+NDIR]) {
          U[i][j][NZl+k] = mpi_rbuf[mpi_bc_rbuf[Z+NDIR]][(i*NYl + j)*GZ + k];
        } else {
          U[i][j][k+NZl] = U[i][j][k];
          bc_fix(i,j,k+NZl,i,j,k);
        }
        calc_xtra(Xtra[i][j][k+NZl], U[i][j][k+NZl], i, j, k+NZl);
      }
    }
  }
}

void bc_init()
{
}
