
#ifndef CHAOS_H
#define CHAOS_H

#include "numtypes.h"
#include "primes.h"

// data structure for ONE draw of the random input parameters
struct Chaos {
  // real arrays only!
  
  // initial data
  real uniform [N_UNIFORM];
  real normal  [N_NORMAL];
  
  // topography
  real t_uniform [T_UNIFORM];
  real t_normal  [T_NORMAL];
  
  // material coefficient
  real m_uniform [M_UNIFORM];
  real m_normal  [M_NORMAL];
};

extern Chaos chaos;

// creates ONE draw of the random input paameters
Chaos chaos_draw ();

// initializes iid array
void chaos_init (long_int offset=0);

#endif
