
/* EQUATION SPECIFIC FVM routines
 * Buckley-Leverett (scalar nonlinear conservation law)
 */

///::title:: Buckley-Leverett (scalar nonlinear conservation law)
///::consts:: TOTAL_FLOW_RATE=1.0 ROCK_PERMEABILITY=1.0

#include "equation.h"

void time_invariant_vars_init () {}

void apply_constraints (ConservedVars &CV, XtraVars &XV)
{
  // Constraints for ConservedVars
  if (CV.So < 0.0) CV.So = 0.0;
  if (CV.So > 1.0) CV.So = 1.0;
  // Constraints for XtraVars
  if (XV.Sw < 0.0) XV.Sw = 0.0;
  if (XV.Sw > 1.0) XV.Sw = 1.0;
}

#if INDICATOR == 1
// Oil saturation So
real indicator(int i, int j, int k, int d)
{
  ConservedVars &Uijk = U[i][j][k];
  return Uijk.So;
}
#endif

void bc_fix (int i, int j, int k, int l, int m, int n) {}
