
/* EQUATION SPECIFIC FVM routines
 * Euler (Euler equations of gas dynamics)
 */

///::title:: Euler (Euler equations of gas dynamics)
///::consts:: NO_B=1

#include "equation.h"

void apply_constraints (ConservedVars &CV, XtraVars &XV)
{
  // Constraints for ConservedVars
  if (CV.rho < 0.0) CV.rho = 0.0;
  if (CV.E   < 0.0) CV.E   = 0.0;
  // Constraints for XtraVars
  if (XV.p   < 0.0) XV.p   = 0.0;
}

#if INDICATOR == 1
// rho
real indicator(int i, int j, int k, int d)
{
  ConservedVars &Uijk = U[i][j][k];
  return Uijk.rho;
}
#endif

void bc_fix (int i, int j, int k, int l, int m, int n) {}
