
/* EQUATION SPECIFIC FVM routines
 * MHD (Magneto-HydroDynamics equations)
 */

///::title:: MHD (Magneto-HydroDynamics equations)
///::vars:: POWELL=1
///::macro:: SUB_STEP_HOOK @ if (POWELL) powell_source(us, Bs, lV, rV, i, j, k, d);

#include "equation.h"

void time_invariant_vars_init () {}

real calc_max_speed (const ConservedVars &CV, const XtraVars &XV, int d)
{
    return fabs(XV.u[d]) + XV.cf[d];
}

void apply_constraints (ConservedVars &CV, XtraVars &XV)
{
  // Constraints for ConservedVars
  if (CV.rho < 0.0) CV.rho = 0.0;
  if (CV.E   < 0.0) CV.E   = 0.0;
  // Constraints for XtraVars
  if (XV.p   < 0.0) XV.p   = 0.0;
}

#if INDICATOR == 1
// rho + B^2
real indicator(int i, int j, int k, int d)
{
  ConservedVars &Uijk = U[i][j][k];
  return Uijk.rho + Uijk.B.sqr();
}
#endif

void bc_fix (int i, int j, int k, int l, int m, int n) {}
