
/* EQUATION SPECIFIC FVM routines
 * Wave (Wave equation, 2nd type)
 */

///::title:: Wave (Wave equation)
///::vars:: MATERIAL_OFFSET=0.0 MATERIAL_SCALING=1.0 HISTOGRAMS=0
///::depends:: material

#include "equation.h"

#include "material.h"

void time_invariant_vars_init ()
{
  #if BUFFERED_MATERIAL
  material_c_init();
  #endif
  for (int i = -GX; i < NXl+GX; i++)
    for (int j = -GY; j < NYl+GY; j++)
      for (int k = -GZ; k < NZl+GZ; k++)
        Xtra[i][j][k].c = MATERIAL_OFFSET + MATERIAL_SCALING * c(i,j,k);
}

real calc_max_speed (const ConservedVars &CV, const XtraVars &XV, int d)
{
  return sqrt(XV.c);
}

#if HISTOGRAMS
real get_histogram_quantity () {
  real c_max = 0;
  for (int i = 0; i < NXl; i++)
    for (int j = 0; j < NYl; j++)
      for (int k = 0; k < NZl; k++)
        if (Xtra[i][j][0].c > c_max)
          c_max = Xtra[i][j][0].c;
  return c_max;
}
#endif

void apply_constraints (ConservedVars &CV, XtraVars &XV)
{
  // Constraints for ConservedVars
  // Constraints for XtraVars
  if (XV.E < 0.0) XV.E = 0.0;
  if (XV.c < 0.0) XV.E = 0.0;
}

#if INDICATOR == 1
real indicator(int i, int j, int k, int d)
{
  ConservedVars &Uijk = U[i][j][k];
  return Uijk.p;
}
#endif

void bc_fix (int i, int j, int k, int l, int m, int n) {}
