
/* EQUATION SPECIFIC FVM routines for FLUX
 * Standard deterministic flux (Burgers' equation)
 */

///::title:: Deterministic (Burgers' multi-D)

#include "equation.h"

real calc_max_speed (const ConservedVars &CV, const XtraVars &XV, int d)
{
  return fabs(CV.u);
}

void calc_point_flux(ConservedVars &F, const AllVariables &V, int d)
{
  F.u = V.U.u * V.U.u / 2.0;
}

void calc_xtra(XtraVars &Xijk, const ConservedVars &Uijk, int i, int j, int k)
{
  Xijk.E = Uijk.u * Uijk.u / 2.0;
}

void calc_all_vars(AllVariables &V, const PrimitiveVars &P)
{
  P.toConservedVars(V.U);
  V.XU.E = P.u * P.u / 2.0;
}
