
/* EQUATION SPECIFIC FVM routines for FLUX
 * Standard deterministic flux (Linear Advection: scalar linear conservation law)
 */

///::title:: Deterministic (Linear Advection)
///::macro:: SPEED_HOOK @ 1.0

#include "equation.h"

void calc_point_flux(ConservedVars &F, const AllVariables &V, int d)
{
  F.u = SPEED_HOOK * V.U.u;
}

void calc_xtra(XtraVars &Xijk, const ConservedVars &Uijk, int i, int j, int k)
{
  Xijk.E = Uijk.u * Uijk.u / 2.0;
}

void calc_all_vars(AllVariables &V, const PrimitiveVars &P)
{
  P.toConservedVars(V.U);
  V.XU.E = P.u * P.u / 2.0;
}
