
#include "material.h"

#include "material-fft.h"

///::title:: Log-normal material coefficient using FFT
///::vars:: VARIANCE=1.0 CORRELATION_LENGTH=0.5
///::consts:: BUFFERED_MATERIAL=1
///::consts:: M_UNIFORM=0 M_NORMAL=NX*NY*NZ
///::depends:: material-fft
///::macro:: LEVEL_INIT_HOOK material-fft.h material_fft_init();
///::macro:: LEVEL_EXIT_HOOK material-fft.h material_fft_exit();

void material_c_init () {
  material_fft_draw_sample ();
}

real material_covariance_kernel (const vector &x1, const vector &x2) {
  return sqr(VARIANCE) * exp( -dist_periodic(x1,x2) / CORRELATION_LENGTH );
}

/*
Since BUFFERED_MATERIAL=1, routine c() is NOT needed;
all needed routines are in material-fft.h and material-fft.cpp
*/
