
#include "material.h"

#include "chaos.h"

///::title:: Log-Uniform Karhunen-Loeve expansion (1D version)
///::vars:: KL=10 MATERIAL_SCALING=0.1
///::consts:: M_UNIFORM=KL M_NORMAL=0 KL_DECAY=2.5

real c (real x, real y, real z) {
  
  // Karhunen–Loeve expantion of log(c) consisting of KL basis functions
  real value = 1.0;
  for (int m=1; m<=KL; m++)
    value *= exp(pow(m,-KL_DECAY/2.0) * sin(m*pi*x) * chaos.m_uniform[m-1]);
  return value;
}
