
#include "equation.h"
#include "chaos.h"

///::title:: Riemann initial data (Buckley-Leverett)
///::vars:: NX=512 MAXT=0.4 LEFT_VALUE=0.25 RIGHT_VALUE=0.85 LOCATION=1.0
///::consts:: MAXX=2
///::bc:: NEUMANN

void initial_data (PrimitiveVars &v, real x, real y, real z)
{
  if (x < LOCATION)
    v.So = LEFT_VALUE;
  else
    v.So = RIGHT_VALUE;
}
