
#include "equation.h"
#include "chaos.h"

///::title:: Riemann shock (at x = 1.0, deterministic)
///::vars:: NX=512 MAXT=0.5 LEFT_VALUE=1.0 RIGHT_VALUE=0.0 LOCATION=1.0
///::consts:: MAXX=2.5
///::bc:: NEUMANN

void initial_data (PrimitiveVars &v, real x, real y, real z)
{
  if (x < LOCATION)
    v.u = LEFT_VALUE;
  else
    v.u = RIGHT_VALUE;
}
