
#include "equation.h"
#include "chaos.h"

///::title:: Cloud Shock for Euler equations (2d, deterministic)
///::vars:: NX=128 NY=128
///::consts:: MAXX=1 MAXY=1 MAXT=0.06
///::bc:: NEUMANN

void initial_data (PrimitiveVars &v, real x, real y, real z)
{
  if (x < 0.04) {
    v.rho = 3.86859;
    v.u[X] = 11.2536;
    v.p = 167.345;
  } else {
    real r = sqr(x-0.25) + sqr(y-0.5);
    real phi = (x-0.25) / sqrt(r);
    if ( sqr(x-0.25) + sqr(y-0.5) <= sqr(0.15) )
      v.rho = 10.0;
    else
      v.rho = 1.0;
    v.p = 1.0;
  }
}
