
#include "equation.h"
#include "chaos.h"

///::title:: Cloud Shock for Euler equations (3d, deterministic)
///::vars:: NX=64 NY=64 NZ=64
///::consts:: MAXX=1 MAXY=1 MAXZ=1 MAXT=0.06
///::consts:: N_UNIFORM=4 N_NORMAL=0
///::bc:: NEUMANN

void initial_data (PrimitiveVars &v, real x, real y, real z)
{
  if (x < 0.04 + 0.02*chaos.uniform[0]) {
    v.rho = 3.86859 + 0.1*chaos.uniform[1];
    v.u[X] = 11.2536;
    v.p = 167.345 + 5*chaos.uniform[2];
  } else {
    if (sqr(x-0.25) + sqr(y-0.5) + sqr(z-0.5) <= sqr(0.13+0.04*chaos.uniform[3]))
      v.rho = 10.0;
    else
      v.rho = 1.0;
    v.p = 1.0;
  }
}
