
#include "equation.h"
#include "chaos.h"

///::title:: Sod shock tube (stochastic shock location and amplidute)
///::vars:: NX=512
///::consts:: MAXX=2.5 MAXT=0.5
///::consts:: N_UNIFORM=2 N_NORMAL=0
///::bc:: NEUMANN

void initial_data (PrimitiveVars &v, real x, real y, real z)

{
  if (x < 1.0 + 0.05*(2*chaos.uniform[0]-1)) {
    v.rho = 1.0;
    v.u[X] = 0.0;
    v.p = 1.0;
  } else {
    v.rho = 0.125 + 0.05*(2*chaos.uniform[1]-1);
    v.u[X] = 0.0;
    v.p = 0.1;
  }
}
