
#include "equation.h"
#include "chaos.h"

///::title:: Orszag Tang Vortex (8 sources of uncertainty)
///::vars:: NX=128 NY=128
///::consts:: MAXX=2 MAXY=2 MAXT=1
///::consts:: N_UNIFORM=8 N_NORMAL=0
///::bc:: REPEAT

void initial_data (PrimitiveVars &v, real x, real y, real z)
{
  x *= pi;
  y *= pi;

  v.rho = GAMMA*GAMMA * (1 + 0.05*(2*chaos.uniform[0]-1));
  v.u[X] = -sin(y + 0.05*(2*chaos.uniform[1]-1));
  v.u[Y] = sin(x + 0.1*(2*chaos.uniform[2]-1));
  v.p = GAMMA * ( 1 + 0.05*(2*chaos.uniform[3]-1));
  v.B[X] = -sin(y + 0.04*(2*chaos.uniform[4]-1)) * (1 + 0.05*(2*chaos.uniform[5]-1));
  v.B[Y] = sin(2*x + 0.05*(2*chaos.uniform[6]-1)) * (1 + 0.05*(2*chaos.uniform[7]-1));
}
