
#include "equation.h"
#include "chaos.h"

///::title:: Orszag Tang Vortex (2 sources of uncertainty)
///::vars:: NX=128 NY=128
///::consts:: MAXX=2 MAXY=2 MAXT=1
///::consts:: N_UNIFORM=2 N_NORMAL=0
///::bc:: REPEAT

void initial_data (PrimitiveVars &v, real x, real y, real z)
{
  x *= pi;
  y *= pi;

  v.rho = GAMMA*GAMMA;
  v.u[X] = -sin(y + 0.05*chaos.uniform[0]);
  v.u[Y] = sin(x + 0.1*chaos.uniform[1]);
  v.p = GAMMA;
  v.B[X] = -sin(y);
  v.B[Y] = sin(2*x);
}
