
#include "equation.h"
#include "chaos.h"

///::title:: Dambreak with random high water level (2D version)
///::vars:: NX=128 NY=128 MAXT=0.1
///::consts:: MAXX=3 MAXY=3 N_UNIFORM=1 N_NORMAL=0
///::bc:: NEUMANN

void initial_data (PrimitiveVars &v, real x, real y, real z)
{
  if (x < 1.0 + 0.1*(2*chaos.uniform[0]-1) )
    v.h = 3.0;
  else
    v.h = 1.0;
}
