
#include "equation.h"
#include "chaos.h"

///::title:: Tsunami (1D version)
///::vars:: NX=512 MAXT=0.53 BED_OFFSET=0.0 BED_SCALING=1.0
///::vars:: PEAK=0.3 LOCATION=1.8 WIDTH=0.1
///::consts:: MAXX=2 N_UNIFORM=1 N_NORMAL=0
///::bc:: NEUMANN

void initial_data (PrimitiveVars &v, real x, real y, real z)
{
  v.h = 2.0;
  if (LOCATION - WIDTH/2 < x && x < LOCATION + WIDTH/2)
    v.h += PEAK*cos(pi/WIDTH*(x-LOCATION))*chaos.uniform[0];
}
