
#include "equation.h"

///::title:: Gaussian pulse (1D version, zero initial velocity)
///::vars:: NX=512 MAXT=2.0
///::consts:: MAXX=2 N_UNIFORM=0 N_NORMAL=0
///::vars:: SMOOTH_SOLUTION=1
///::bc:: REPEAT

// p_0     = exp(-sqr(x-1)/(2*0.04));
// (p_0)_t = 0.0;

void initial_data (PrimitiveVars &v, real x, real y, real z)
{
  v.p = exp(-sqr(x-1)/(2*0.04));
  v.u[X] = 0.0;
}
