 
#include <mpi.h>

#include "equation.h"

// === mpi_MOMENTS datatypes for ConservedVars and XtraVars

typedef struct {
  unsigned long int weight;
  real mean [SIZE_CV];
  real variance [SIZE_CV];
} moments_CV;

const int count = 3;
const int lengths_CV [count] = {1, SIZE_CV, SIZE_CV};

MPI_Aint offsets_CV [count] = {0, sizeof(unsigned long int), sizeof(unsigned long int) + sizeof(real)*SIZE_CV};

// TODO: should be smth like MPI_INT -> MPI_LONG
MPI_Datatype types [count] = {MPI_INT, mpi_REAL, mpi_REAL};

MPI_Datatype mpi_MOMENTS_CV;
MPI_Type_struct(count, lengths_CV, offsets_CV, types, &mpi_MOMENTS_CV);
MPI_Type_commit(&mpi_MOMENTS_CV);






// === MPI_REDUCE_MOMENTS reduction operator

typedef void (MPI_User_function) ( void * a, void * b, int * len, MPI_Datatype *)

// create MPI operator for reduction of moments
MPI_Op MPI_REDUCE_MOMENTS;

int commute = 1
int MPI_Op_create( MPI_User_function *function, commute, &MPI_REDUCE_MOMENTS);

// === Usage

// TODO: adjust value of 'count'
MPI_Reduce (send_buf, recv_buf, count, mpi_MOMENTS_CV, MPI_REDUCE_MOMENTS, 0, comm_subdomains);