
#include "mlmc.h"
#include "multi.h"

#include <time.h>
#include <fstream>

///::title:: No parallelisation
///::consts:: MULTIX=1 MULTIY=1 MULTIZ=1 MULTIM=1

real multi_dt (real dt)
{
  return dt;
}

void multi_bc ()
{
}

void multi_init (int argc, char **argv)
{
  multix = 0;
  multiy = 0;
  multiz = 0;
  
  multi_rank = 0;
  multi_rank_samplers = 0;
  
  multi_main = 1;
  multi_level_root = 1;
  multi_domain_root = 1;
  multi_samplers_root = 1;
  
  LEVEL_BEGIN = 0;
  LEVEL_END   = L;
}

void multi_run_compatibility_checks () {}
void multi_level_init               () {}
void multi_level_setup              () {}
void multi_combine_samples          () {}
void multi_combine_levels           () {}
void multi_combine_hist_data        () {}
void multi_cleanup                  () {}
void multi_finalise                 () {}

double clock_timer;

void start_timer () {
  if (multi_main) clock_timer = clock();
}

void stop_timer () {
  
  if (multi_main) {
    double runtime;
    runtime = (clock() - clock_timer) / CLOCKS_PER_SEC;
    
    std::ofstream runtimef (RUNTIME_FILE);
    runtimef << "clock_runtime=" << runtime << std::endl;
    runtimef << "cores=1" << std::endl;
    runtimef.flush();
    
    std::cout << std::endl;
    
    std::cout << " :: CPU clock time: ";
    print_runtime(runtime);
    std::cout << std::endl;
  }
}
