
#include "structures.h"
#include "volumes.h"

#include <fstream>

// Saver class for saving volumes in a binary format
class Saver
{
private:
  // pointer to data file for volumes
  std::ofstream *data;
  // pointer to data file for time steps
  std::ofstream *times;
  // pointers to volumes
  volume <ConservedVars, 1> *CV;
  volume <XtraVars, 1>      *XV;
  // should variance be nonnegative?
  bool nonnegative;

public:
  // constructor (sets the file name, pointers, etc.)
  Saver(const std::string quantity="mean");
  // destructor
  ~Saver();
  // write in a binary mode to the file
  void write(real &r);
  // write one snapshot to the file
  void step(volume <ConservedVars, 1> &CV, volume <XtraVars, 1> &XV, real t_halt);
  // iterate over all snapshots
  void snapshots();
};

// save histograms data
#if HISTOGRAMS
void save_hist_data ();
#endif
