
#include "structures-base.h"
#include "structures.h"

// === ConservedVars

// member operators

void ConservedVarsBase::operator += (const ConservedVarsBase &a) {
  for (int m=0; m<SIZE_CV; m++)
    realCast(*this) [m] += realCast(a) [m];
}

void ConservedVarsBase::operator -= (const ConservedVarsBase &a) {
  for (int m=0; m<SIZE_CV; m++)
    realCast(*this) [m] -= realCast(a) [m];
}

void ConservedVarsBase::operator *= (const ConservedVarsBase &a) {
  for (int m=0; m<SIZE_CV; m++)
    realCast(*this) [m] *= realCast(a) [m];
}

void ConservedVarsBase::operator /= (const ConservedVarsBase &a) {
  for (int m=0; m<SIZE_CV; m++)
    realCast(*this) [m] /= realCast(a) [m];
}

void ConservedVarsBase::operator *= (const real r) {
  for (int m=0; m<SIZE_CV; m++)
    realCast(*this) [m] *= r;
}

void ConservedVarsBase::operator /= (const real r) {
  for (int m=0; m<SIZE_CV; m++)
    realCast(*this) [m] /= r;
}

void ConservedVarsBase::operator += (const real r) {
  for (int m=0; m<SIZE_CV; m++)
    realCast(*this) [m] += r;
}

void ConservedVarsBase::operator -= (const real r) {
  for (int m=0; m<SIZE_CV; m++)
    realCast(*this) [m] -= r;
}

// === XtraVars

// member operators

void XtraVarsBase::operator += (const XtraVarsBase &a) {
  for (int m=0; m<SIZE_XV; m++)
    realCast(*this) [m] += realCast(a) [m];
}

void XtraVarsBase::operator -= (const XtraVarsBase &a) {
  for (int m=0; m<SIZE_XV; m++)
    realCast(*this) [m] -= realCast(a) [m];
}
  
void XtraVarsBase::operator *= (const XtraVarsBase &a) {
  for (int m=0; m<SIZE_XV; m++)
    realCast(*this) [m] *= realCast(a) [m];
}
  
void XtraVarsBase::operator /= (const XtraVarsBase &a) {
  for (int m=0; m<SIZE_XV; m++)
    realCast(*this) [m] /= realCast(a) [m];
}

void XtraVarsBase::operator /= (const real r) {
  for (int m=0; m<SIZE_XV; m++)
    realCast(*this) [m] /= r;
}

void XtraVarsBase::operator *= (const real r) {
  for (int m=0; m<SIZE_XV; m++)
    realCast(*this) [m] *= r;
}

void XtraVarsBase::operator += (const real r) {
  for (int m=0; m<SIZE_XV; m++)
    realCast(*this) [m] += r;
}

void XtraVarsBase::operator -= (const real r) {
  for (int m=0; m<SIZE_XV; m++)
    realCast(*this) [m] -= r;
}

// === PrimitiveVars

// member operators

void PrimitiveVarsBase::operator += (const PrimitiveVarsBase &a) {
  for (int m=0; m<SIZE_PV; m++)
    realCast(*this) [m] += realCast(a) [m];
}

void PrimitiveVarsBase::operator -= (const PrimitiveVarsBase &a) {
  for (int m=0; m<SIZE_PV; m++)
    realCast(*this) [m] -= realCast(a) [m];
}
  
void PrimitiveVarsBase::operator *= (const PrimitiveVarsBase &a) {
  for (int m=0; m<SIZE_PV; m++)
    realCast(*this) [m] *= realCast(a) [m];
}
  
void PrimitiveVarsBase::operator /= (const PrimitiveVarsBase &a) {
  for (int m=0; m<SIZE_PV; m++)
    realCast(*this) [m] /= realCast(a) [m];
}

void PrimitiveVarsBase::operator /= (const real r) {
  for (int m=0; m<SIZE_PV; m++)
    realCast(*this) [m] /= r;
}

void PrimitiveVarsBase::operator *= (const real r) {
  for (int m=0; m<SIZE_PV; m++)
    realCast(*this) [m] *= r;
}

void PrimitiveVarsBase::operator += (const real r) {
  for (int m=0; m<SIZE_PV; m++)
    realCast(*this) [m] += r;
}

void PrimitiveVarsBase::operator -= (const real r) {
  for (int m=0; m<SIZE_PV; m++)
    realCast(*this) [m] -= r;
}
