
/*
 * Template structures for ConservedVars, and XtraVars
 * Operator overloading is only declared here; it is defined in "structures.cpp"
 */

#ifndef STRUCTURES_BASE_H
#define STRUCTURES_BASE_H

#include "numtypes.h"

// === base structure for ConservedVars

struct ConservedVarsBase {
  void operator += (const ConservedVarsBase &a);
  void operator -= (const ConservedVarsBase &a);
  void operator *= (const ConservedVarsBase &a);
  void operator /= (const ConservedVarsBase &a);
  void operator += (const real r);
  void operator -= (const real r);
  void operator *= (const real r);
  void operator /= (const real r);
};

// === base structure for XtraVars

struct XtraVarsBase {
  void operator += (const XtraVarsBase &a);
  void operator -= (const XtraVarsBase &a);
  void operator *= (const XtraVarsBase &a);
  void operator /= (const XtraVarsBase &a);
  void operator += (const real r);
  void operator -= (const real r);
  void operator *= (const real r);
  void operator /= (const real r);
};

// === base structure for PrimitiveVars

struct PrimitiveVarsBase {
  void operator += (const PrimitiveVarsBase &a);
  void operator -= (const PrimitiveVarsBase &a);
  void operator *= (const PrimitiveVarsBase &a);
  void operator /= (const PrimitiveVarsBase &a);
  void operator += (const real r);
  void operator -= (const real r);
  void operator *= (const real r);
  void operator /= (const real r);
};

#endif
