
#include "topography.h"

#include "equation.h"
#include "multi.h"

real b (const int &i, const int &j) {
  return b ( (i + 0.5 + NXl*multix) * dx[X], (j + 0.5 + NYl*multiy) * dx[Y] );
}

#if STANDARD_TOPOGRAPHY_QUAD

// 2nd order accurate source quadrature
void compute_source (const int &i, const int &j) {
  Source[i][j][0].hu[X] = - GRAVITY * U[i][j][0].h * ( Xtra[i+1][j][0].b - Xtra[i-1][j][0].b ) / (2*dx[X]);
  if (HAVE_DIR(Y))
    Source[i][j][0].hu[Y] = - GRAVITY * U[i][j][0].h * ( Xtra[i][j+1][0].b - Xtra[i][j-1][0].b ) / (2*dx[Y]);
}

#endif
