
#include "topography.h"

#include "equation.h"
#include "multi.h"
#include "chaos.h"

///::title:: Karhunen-Loeve expansion (1D version)
///::vars:: KL=8
///::consts:: T_UNIFORM=KL T_NORMAL=0 KL_DECAY=1.1

real b (real x, real y) {
  // Karhunen-Loeve expansion for topography b consisting of KL basis functions
  real value = 0.0;
  for (int m=1; m<=KL; m++)
    value += pow(m,-KL_DECAY) * sin(m*pi*x) * (2*chaos.t_uniform[m-1] - 1);
  return BED_OFFSET + BED_SCALING * 0.5 * value;
}
